<?php

	/**
	 * Dieses Modul erlaubt die Adressvalidation
	 * @author hartmut
	 */
	class wpsg_mod_addressvalidation extends wpsg_mod_basic
	{
	
		var $lizenz = 2;
		var $id = 3250;
		var $version = "4.2.8";
		var $hilfeURL = 'http://wpshopgermany.de/?p=4670347';
	
		/**
		 * Constructor
		 */
		public function __construct()
		{
			
			global $wpdb;
			
			parent::__construct();
				
			$this->name = __('Adressvalidation', 'wpsg');
			$this->group = __('Sonstiges', 'wpsg');
			$this->desc = __('Ermöglicht die Prüfung der Adresse.', 'wpsg');
					
		} // public function __construct()
		
		public function install()
		{
		
			require_once(WPSG_PATH_WP.'/wp-admin/includes/upgrade.php');
				
			$this->shop->checkDefault('wpsg_mod_addressvalidation_apikey', '', false, true);
				
		} // public function install()
		
		public function settings_edit()
		{
				
			$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_addressvalidation/settings_edit.phtml');
				
		}
		
		public function settings_save()
		{
				
		    $this->shop->update_option('wpsg_mod_addressvalidation_apikey', $_REQUEST['wpsg_mod_addressvalidation_apikey'], false, false, WPSG_SANITIZE_TEXTFIELD);
		
		} // public function settings_save()
		
		public function wpsg_enqueue_scripts() {

			$id = wpsg_get_the_id();

			if (!is_admin() && wpsg_isSizedInt($id) && (
                    $id == $this->shop->get_option('wpsg_page_basket') ||
                    $id == $this->shop->get_option('wpsg_page_mod_kundenverwaltung_profil') ||
                    $id == $this->shop->get_option('wpsg_page_mod_kundenverwaltung_registrierung')
				))
			{
				
				$gurl = $this->shop->getRessourceURL('mods/mod_addressvalidation/addressvalidation.js');
				
				wp_register_script('wpsg-mod_addressvalidation-valid', $gurl, array(), null);
				wp_enqueue_script('wpsg-mod_addressvalidation-valid');
		
			}
				
		} // public wpsg_enqueue_scripts()

		/**
		 * Varlidierung durchführen
		 * Könnte man vielleicht über die Funktion wpsg_SystemController->get_url_post_content durchführen
		 * @param $state
		 * @param $error
		 * @param $arCheckout
		 */
		public function checkCheckout(&$state, &$error, &$arCheckout)
		{
	 
			if (
				($state == 1) ||
				($state >= 1 && $this->shop->hasMod('wpsg_mod_onepagecheckout'))
				)
			{
				
				$pflicht = $GLOBALS['wpsg_sc']->loadPflichtFeldDaten();
				
				// $arCheckout['strasse']  (plz, ort, land, nr)
				$strasse = $arCheckout['strasse'];
				$ort = $arCheckout['ort'];
				$plz = $arCheckout['plz'];
				$nr = '';
				
				if (isset($arCheckout['nr'])) $nr = $arCheckout['nr'];
				
				$land = $arCheckout['land'];
				
				if (wpsg_isSizedInt($land))
				{
				
					$oCountry = wpsg_country::getInstance($land);
					$land = strtolower($oCountry->getShorttext());
					
				} else $land = '';
				
				$astr = $strasse.$nr.$plz.$ort.$land;
				
				$key = $this->shop->get_option('wpsg_mod_addressvalidation_apikey');
					
				$strasse = $strasse.rtrim(' '.$nr);
				
					
				if ($astr != wpsg_getStr($_SESSION['wpsg']['Adressstring1']))
				{
					$_SESSION['wpsg']['Adressstring1'] = $astr;
					
					// build API request
					$APIUrl = 'http://api.address-validator.net/api/verify';
					$Params = array('StreetAddress' => $strasse,
							'City' => $ort,
							'PostalCode' => $plz,
							//'State' => $State,
							'CountryCode' => $land,
							//'Locale' => $Locale,
							'APIKey' => $key);
					$Request = http_build_query($Params, '', '&');
					$ctxData = array(
							'method'=>"POST",
							'header'=>"Connection: close\r\n".
							"Content-Type: application/x-www-form-urlencoded\r\n".
							"Content-Length: ".strlen($Request)."\r\n",
							'content'=>$Request);
					$ctx = stream_context_create(array('http' => $ctxData));
					
					// send API request
					$result = json_decode(file_get_contents($APIUrl, false, $ctx));
					
					// check API result
					if ($result && $result->{'status'} == 'VALID') {
						$formattedaddress = $result->{'formattedaddress'};
					} else {
						//echo $result->{'info'};
						if (($result->{'status'} == 'SUSPECT') || ($result->{'status'} == 'INVALID'))
						{
							
							if ($pflicht['strasse'] != '1') $_SESSION['wpsg']['errorFields'][] = 'strasse';
							if ($pflicht['nr'] != '1') $_SESSION['wpsg']['errorFields'][] = 'nr';
							if ($pflicht['ort'] != '1') $_SESSION['wpsg']['errorFields'][] = 'ort';
							if ($pflicht['plz'] != '1') $_SESSION['wpsg']['errorFields'][] = 'plz';
							if ($pflicht['land'] != '1') $_SESSION['wpsg']['errorFields'][] = 'land';
							$this->shop->addFrontendError(__('Bitte die Kundenadresse (Straße, Hausnummer, PLZ, Ort und Land kontrollieren (Adressvalidation)', 'wpsg'));
							$error = true;
							
						}
						else
						{
							
							$this->shop->addFrontendError(wpsg_translate(__('Probleme mit dem Server der Adressvalidation (#1#)', 'wpsg'), $result->{'status'}));
							$error = true;
							
						}
							
					}
				
				}
				
				if (array_key_exists('diff_shippingadress', $arCheckout))
				{
					// $arCheckout['diff_shippingadress'], shipping_(strasse, plz, ort, land)
					$strasse = $arCheckout['shipping_strasse'];
					$ort = $arCheckout['shipping_ort'];
					$plz = $arCheckout['shipping_plz'];
					$nr = wpsg_getStr($arCheckout['shipping_nr']);
					$land = $arCheckout['shipping_land'];
					
					if (wpsg_isSizedInt($land))
					{
					
						$oCountry = wpsg_country::getInstance($land);
						$land = strtolower($oCountry->getShorttext());
						
					} else $land = '';
					
					
					$astr = $strasse.$nr.$plz.$ort.$land;
						
					$key = $this->shop->get_option('wpsg_mod_addressvalidation_apikey');
						
					if (wpsg_isSizedInt($this->shop->get_option('wpsg_showNr'))) {
					
						$strasse = $strasse.' '.$nr;
					
					}
						
					if ($astr != wpsg_getStr($_SESSION['wpsg']['Adressstring2']))
					{
						$_SESSION['wpsg']['Adressstring2'] = $astr;
							
						// build API request
						$APIUrl = 'http://api.address-validator.net/api/verify';
						$Params = array('StreetAddress' => $strasse,
								'City' => $ort,
								'PostalCode' => $plz,
								//'State' => $State,
								'CountryCode' => $land,
								//'Locale' => $Locale,
								'APIKey' => $key);
						$Request = http_build_query($Params, '', '&');
						$ctxData = array(
								'method'=>"POST",
								'header'=>"Connection: close\r\n".
								"Content-Type: application/x-www-form-urlencoded\r\n".
								"Content-Length: ".strlen($Request)."\r\n",
								'content'=>$Request);
						$ctx = stream_context_create(array('http' => $ctxData));
						
						// send API request
						$result = json_decode(file_get_contents($APIUrl, false, $ctx));
						
						// check API result
						if ($result && $result->{'status'} == 'VALID') {
							$formattedaddress = $result->{'formattedaddress'};
						} else {
							//echo $result->{'info'};
							if (($result->{'status'} == 'SUSPECT') || ($result->{'status'} == 'INVALID'))
							{
						
								if ($pflicht['strasse'] != '1') {
									
									$_SESSION['wpsg']['errorFields'][] = 'shipping_strasse';
									
									if (wpsg_getStr($pflicht['wpsg_showNr']) === '1') {
									
										$_SESSION['wpsg']['errorFields'][] = 'shipping_nr';
										
									}
									
								}
								
								if ($pflicht['ort'] != '1') $_SESSION['wpsg']['errorFields'][] = 'shipping_ort';
								if ($pflicht['plz'] != '1') $_SESSION['wpsg']['errorFields'][] = 'shipping_plz';
								if ($pflicht['land'] != '1') $_SESSION['wpsg']['errorFields'][] = 'shipping_land';
								$this->shop->addFrontendError(__('Bitte die Lieferadresse (Straße, Hausnummer, PLZ, Ort und Land kontrollieren (Adressvalidation)', 'wpsg'));
								$error = true;
						
							}
							else
							{
						
								$this->shop->addFrontendError(__('Probleme mit dem Server (Adressvalidation)'.' ('.$result->{'status'}.')', 'wpsg'));
								//$error = true;
						
							}
						
						}
					
					}
					
				}
					
			}
				
		} // public function checkCheckout(&$state, &$error, &$arCheckout)
		
	}

?>